loader ={}

loader.map = "!\"$%%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[#]^_`abcdefghijklmnopqrstuvwxyz{~}"
loader.table = {idx={},code={[0]=""}}
loader.args = {}
loader.argc = 0
loader.nums = {}
loader.numc = 0
loader.ns = 0
loader.ns_pow = {[0]=0}
loader.ns_pown = 5
loader.lip = 2147483647
loader.l_segments = 20

loader.ifx = function(n) 
    local fi = math.tointeger(n)
    if fi == nil then
        return 0
    end
    return fi
end

loader.init = function()
    local size_t = string.len(loader.map)
    local ptrIdx = ""
    loader.ns = size_t
    for i = 1, size_t do 
        ptrIdx = string.sub(loader.map,i,i)
        loader.table.code[i-1] = ptrIdx
        loader.table.idx[ptrIdx] = i - 1
    end
    for i = 0, loader.ns_pown-1 do
        loader.ns_pow[i] = loader.ifx(math.floor(loader.ns^i))
    end
end

loader.clear_args = function()
    for ci = loader.argc, 1, - 1 do
        loader.args[ci] = nil
    end
    loader.argc = 0
end

loader.clear_nums = function()
    for ci = loader.numc, 1, - 1 do
        loader.nums[ci] = nil
    end
    loader.numc = 0
end


loader.toint = function (str)
   local size_t = string.len(str)
   if size_t > loader.ns_pown or size_t < 1 then
      return 0  
   else
      local r = 0
      for k = size_t, 1, -1 do
          r = r + loader.table.idx[string.sub(str,k,k)] * loader.ns_pow[size_t-k]
      end
      return loader.ifx(math.floor(r))
   end
end

loader.gen = function(N)
   if N < 0 or N > loader.lip then
        error("Incorrect number min: 0, max: "..loader.lip)
        return ""
   else
        local x = N
        local y = 0
        local r = ""
        while(x>0) do
            y = loader.ifx(math.floor(x %% loader.ns))
            r = loader.table.code[y]..r
            x = loader.ifx(x // loader.ns)
        end
       return r
   end
end

loader.coding = function()
    if loader.numc > 0 then
       for k = 1, loader.numc do
          loader.args[k] = loader.gen(loader.nums[k])
          loader.argc = loader.argc + 1
       end
       loader.clear_nums()
       return true
    else
        error("The loader numbers or nums are empty!")
        return false
    end
end
    
    
loader.encoding = function ()
    if loader.argc > 0 then
       for k = 1, loader.argc do
          loader.nums[k] = loader.toint(loader.args[k])
          loader.numc = loader.numc + 1
       end
       loader.clear_args()
       return true
    else
        error("The loader arguments are empty!")
        return false
    end
end

loader.gc = function (opt,...)
    local list = {...}
    if not opt then
        loader.clear_nums()
    end
    if type(list[1]) == "table" then
        list = list[1]
    end
    for k in pairs(list) do
        loader.numc = loader.numc + 1
        if type(list[k]) ~= "number" then
            list[k] = 0
        end
        loader.nums[loader.numc] = list[k]
    end
end

loader.ga = function (astr, isAdd)
    if not isAdd then
       loader.clear_args()
    end
    if astr == nil then
        local lstr = GetEventPlayerChatString()
        loader.argc = -1
        for k in string.gmatch(lstr,"[^%%s]+") do
            if loader.argc == -1 then
                loader.argc = loader.argc + 1 
            else
                loader.argc = loader.argc + 1 
                loader.args[loader.argc] = k
            end
        end
    else
        for k in string.gmatch(astr,"[^%%s]+") do
            loader.argc = loader.argc + 1 
            loader.args[loader.argc] = k
        end
   end
end

loader.tabcpy = function(dest_table)
    if loader.numc == 0 then
       error("The loader numbers are empty!")
       return
    end
    if type(dest_table) == "table" then
        if dest_table.size ~= nil and dest_table.numt ~= nil and type(dest_table.numt) == "table" then
            dest_table.size = loader.numc
            for k = 1, loader.numc do
                dest_table.numt[k] = loader.nums[k]
            end
        else
            error("Incorrect  table model, needs: { size=0, numt ={} }") 
        end
    else
       error("This isn't a table {}") 
    end
end

loader.zip_options = function (cc,...)
    local list = {...}
    local nn = 0
    local doc = 0
    local r = 0
    if type(list[1]) == "table" then list = list[1] end
    if type(cc) ~= "number" or cc > 1000 then
        error("Bad opter, need is number type and less than 1000 or equitable it.")
    else
        for k in pairs(list) do
           if type(list[k]) ~= "number" then list[k] = 0 end
           nn = nn + loader.ifx(math.floor(cc^doc)) * list[k]
           if nn >= 0 and nn <= loa then
               r = nn
           else
                break
           end
           doc = doc + 1
       end
    end
    return r
end

loader.unzip_options = function (cc,tb,nn)
    local r = true
    if type(cc) ~= "number" then
        return false
    end
    if type(cc) ~= "number" or cc > 1000 then
        error("Bad unopter, need is number type and less than 1000 or equitable it.")
        r = false
    else
       if type(tb) ~= "table" then
            error("Bad arg. 'tb', need is a table and it's desirable so empty.")
            r = false
       else
            local x  = nn
            local ix = 0
            local y  = 0
            while(x>0) do
                ix = ix + 1
                y = loader.ifx(math.floor(x %% cc))
                tb[ix] = y
                x = loader.ifx(x // cc)
            end
       end
    end
    return r
end

loader.pa = function(plr,str)
    if loader.argc > 0 then 
        local sv = {}
        local p = 0
        local l = ""
        for k = 1, loader.argc do
           p = loader.ifx(k // loader.l_segments + 1 )
           if sv[p] == nil then sv[p] = "-l"..p end
           sv[p]=sv[p].." "..loader.args[k]
        end
        if plr == GetLocalPlayer() then
            PreloadGenClear()
            for v in pairs(sv) do
                Preload(sv[v])
            end
            PreloadGenEnd(str)
        end
    else
       error("Error: Loader args are empty!") 
    end
end